"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IterableChannel = void 0;
const promiseWithResolvers_js_1 = require("../common/promiseWithResolvers.js");
class IterableChannel {
    #isClosed = false;
    #nextIteration = (0, promiseWithResolvers_js_1.promiseWithResolvers)();
    iterable = {
        [Symbol.asyncIterator]: () => ({
            next: () => this.#nextIteration.promise,
        }),
    };
    put(value) {
        if (!this.#isClosed) {
            this.#nextIteration.resolve({ done: false, value });
            this.#nextIteration = (0, promiseWithResolvers_js_1.promiseWithResolvers)();
        }
    }
    close() {
        this.#isClosed = true;
        this.#nextIteration.resolve({ done: true, value: undefined });
    }
}
exports.IterableChannel = IterableChannel;
//# sourceMappingURL=IterableChannel.js.map