import { type ExtractAsyncIterValue } from '../common/ExtractAsyncIterValue.js';
export { useAsyncIterable, type IterationResult };
declare function useAsyncIterable<TValue>(input: AsyncIterable<TValue>, initialValue?: undefined): IterationResult<TValue, undefined>;
declare function useAsyncIterable<TValue, TInitValue = undefined>(input: TValue, initialValue?: TInitValue): IterationResult<TValue, TInitValue>;
type IterationResult<TValue, TInitValue = undefined> = {
    /** The most recent value received */
    value: ExtractAsyncIterValue<TValue> | TInitValue;
} & ({
    pendingFirst: true;
    done: false;
    error: undefined;
} | ({
    pendingFirst: false;
} & ({
    done: false;
    error: undefined;
} | {
    done: true;
    error: unknown;
})));
