"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAsyncIterable = useAsyncIterable;
const react_1 = require("react");
const useLatest_js_1 = require("../common/hooks/useLatest.js");
const isAsyncIter_js_1 = require("../common/isAsyncIter.js");
const useSimpleRerender_js_1 = require("../common/hooks/useSimpleRerender.js");
function useAsyncIterable(input, initialValue) {
    const rerender = (0, useSimpleRerender_js_1.useSimpleRerender)();
    const stateRef = (0, react_1.useRef)({
        value: initialValue,
        pendingFirst: true,
        done: false,
        error: undefined,
    });
    const latestInputRef = (0, useLatest_js_1.useLatest)(input);
    if (!(0, isAsyncIter_js_1.isAsyncIter)(latestInputRef.current)) {
        (0, react_1.useMemo)(() => { }, [undefined]);
        (0, react_1.useEffect)(() => { }, [undefined]);
        return (stateRef.current = {
            value: latestInputRef.current,
            pendingFirst: false,
            done: false,
            error: undefined,
        });
    }
    else {
        (0, react_1.useMemo)(() => {
            stateRef.current = {
                value: stateRef.current.value,
                pendingFirst: true,
                done: false,
                error: undefined,
            };
        }, [latestInputRef.current]);
        (0, react_1.useEffect)(() => {
            const iterator = latestInputRef.current[Symbol.asyncIterator]();
            let iteratorClosedAbruptly = false;
            (async () => {
                try {
                    for await (const value of { [Symbol.asyncIterator]: () => iterator }) {
                        if (!iteratorClosedAbruptly) {
                            stateRef.current = {
                                value,
                                pendingFirst: false,
                                done: false,
                                error: undefined,
                            };
                            rerender();
                        }
                    }
                    if (!iteratorClosedAbruptly) {
                        stateRef.current = {
                            value: stateRef.current.value,
                            pendingFirst: false,
                            done: true,
                            error: undefined,
                        };
                        rerender();
                    }
                }
                catch (err) {
                    if (!iteratorClosedAbruptly) {
                        stateRef.current = {
                            value: stateRef.current.value,
                            pendingFirst: false,
                            done: true,
                            error: err,
                        };
                        rerender();
                    }
                }
            })();
            return () => {
                iteratorClosedAbruptly = true;
                iterator.return?.();
            };
        }, [latestInputRef.current]);
        return stateRef.current;
    }
}
//# sourceMappingURL=index.js.map