import { type ReactNode } from 'react';
import { type IterationResult } from '../useAsyncIterable/index.js';
export { Iterate, type IterateProps };
declare function Iterate<TVal, TInitialVal = undefined>(props: IterateProps<TVal, TInitialVal>): ReactNode;
type IterateProps<TVal, TInitialVal = undefined> = IteratePropsWithRenderFunction<TVal, TInitialVal> | IteratePropsWithIterableAsChildren;
type IteratePropsWithRenderFunction<TVal, TInitialVal = undefined> = {
    initialValue?: TInitialVal;
    value: TVal;
    children: (nextIterationState: IterationResult<TVal, TInitialVal>) => ReactNode;
};
type IteratePropsWithIterableAsChildren = {
    initialValue?: ReactNode;
    value?: undefined;
    children: ReactNode | AsyncIterable<ReactNode>;
};
